#include <stdio.h>
#include <string.h>


void exe_gplot_Task_Grid(
                          int          my_tid_demo,
                          int          iter_idx_demo,
                          char        *dirname,
                          char        *sub_dirname,
                          char        *filename,
                          int          Ndim,
                          char        *display_name,
                          int          geom_frame_offset[2],
                          int          geom_size[2]
                        )
{
#  include      "gplot.c.h"
#  define       demo_line_Max 80

   char         demo_cmd_str[ 2 * demo_line_Max ];
   char         full_filename_demo[ 2 * demo_line_Max ];
   char         gplot_template_name[ demo_line_Max ];

   const char  *gplot_template[2][2]          = {
                                                 {
                                                  "GNUPLOT_template_1D.cmd",
                                                  "GNUPLOT_template_1D.cmd"
                                                 },
                                                 {
                                                  "GNUPLOT_template_2D_pic.cmd",
                                                  "GNUPLOT_template_2D_mov.cmd"
                                                 }
                                                };
   char         gplot_cmd_file[ demo_line_Max ];

   const int    N_geom                        = 4;
   const int    geom_init[2]                  = {  0, 30 };
   const int    geom_incre[2]                 = { 20, 20 };
   const int    geom_frame_incre[2]           = { 30, 30 };
   int          geom_offset[4][2];
   int          geom_coord[2];
   int          geom_frame;
   int          geom_idx;

   int          xterm_geom_coord[ 2 ];
   int          gplot_geom_size[ 2 ];
   int          gplot_geom_coord[ 2 ];

   char         task_iter_status[ demo_line_Max ];
   char         tmp_fmt[ demo_line_Max ];
   int          idir;

 
      /* create full pathname to the gplot datafile */
      strcpy( full_filename_demo, dirname );
      strcat( full_filename_demo, "/" );
      strcat( full_filename_demo, sub_dirname );
      strcat( full_filename_demo, "/" );
      strcat( full_filename_demo, filename );

      /* prepare the gplot_template_filename for the given Ndim and Iter_Idx */
      if ( iter_idx_demo == 0 )
         strcpy( gplot_template_name, gplot_template[ Ndim-1 ][ 0 ] );
      else
         strcpy( gplot_template_name, gplot_template[ Ndim-1 ][ 1 ] );

      /* prepare for the task_iter_status  */
      sprintf( tmp_fmt, "%s_%s", task_fmt, iter_fmt );
      sprintf( task_iter_status, tmp_fmt, my_tid_demo, iter_idx_demo );

      /* prepare for the gplot command file's name, gplot_cmd_file  */
      sprintf( gplot_cmd_file, "gplot_%s.cmd", task_iter_status );

      /* variable to determine which geom_idx in which geom_frame  */
      geom_idx   = my_tid_demo % N_geom;
      geom_frame = my_tid_demo / N_geom;

      /* determine the plot's relative position (in a frame) w.r.t. geom_size */
      geom_offset[0][0] = 0;            geom_offset[0][1] = 0;
      geom_offset[1][0] = geom_size[0]; geom_offset[1][1] = 0;
      geom_offset[2][0] = 0;            geom_offset[2][1] = geom_size[1];
      geom_offset[3][0] = geom_size[0]; geom_offset[3][1] = geom_size[1];
      
      for ( idir = 0; idir < 2; idir++ )
         geom_coord[ idir ] = geom_init[ idir ]
                            + geom_frame * geom_frame_incre[ idir ]
                            + geom_offset[ geom_idx ][ idir ]
                            + geom_frame_offset[ idir ];

      for ( idir = 0; idir < 2; idir++ )
      {
         xterm_geom_coord[ idir ] = geom_coord[ idir ];
         gplot_geom_size[ idir ]  = geom_size[ idir ];
         gplot_geom_coord[ idir ] = geom_coord[ idir ] + geom_incre[ idir ];
      }

      /* EXcute GNUPLOT  */
      exe_xterm_gplot( full_filename_demo, gplot_template_name,
                       gplot_cmd_file, task_iter_status, display_name,
                       xterm_geom_coord, gplot_geom_size, gplot_geom_coord );

}
