#include <stdio.h>
#include <string.h>
#include "mpi.h"

main( int argc, char **argv )
{
#  define     line_Max  MPI_MAX_PROCESSOR_NAME

   int        my_tid;
   int        ierr;
   int        mpi_argc;
   char     **mpi_argv;

   char       my_exe_name[ 80 ];
   char       filename_stdin[ line_Max ] = "";
   FILE      *file_stdin;
   int        file_stdin_flag;
   int        Ndim;
   int       *Glb_Grid_sz;
   char       type_str[6];
   int        idir, ii;

   int        N_task;
   char      *task_hostnames;
   char      *cptr;

   /*  Init the MPI  */
/*
   if ( argc > 1 )
      for ( ii = 0; ii < argc; ii++ )
      {
         printf( "%d,  %s \n", ii, argv[ ii ] );
         fflush( stdout );
      }
*/

   ierr = MPI_Init( &argc, &argv );
   ierr = MPI_Comm_rank( MPI_COMM_WORLD, &my_tid );

/*
   if ( argc > 1 )
      for ( ii = 0; ii < argc; ii++ )
      {
         printf( "   {%d}  %d  %s \n", my_tid, ii, argv[ ii ] );
         fflush( stdout );
      }
*/


   file_stdin = stdin;
   file_stdin_flag = 0;

   strcpy( my_exe_name, argv[ 0 ] );
   if ( argc > 1 )
   {
      ii = 1;
      while ( ii < argc )
      {
         if ( ! strcmp( argv[ ii ], "-stdinfile" ) )
         {
            ii++;
            strcpy( filename_stdin, argv[ ii ] );
            file_stdin = fopen( filename_stdin, "r" );
            file_stdin_flag = 1;
         }
         ii++;
      }
   }

   if ( my_tid == 0 )
   {
      fprintf( stdout, "My executable name is %s\n", my_exe_name );
      if ( cptr = strrchr( my_exe_name, '/' ) )
         strcpy( my_exe_name, ++cptr );
      fprintf( stdout, "My executable name is %s\n", my_exe_name );
   }

   if ( my_tid == 0 )
   {
      fprintf( stdout, "Enter the Dimensionality of the Grid, Ndim : " );
      fscanf( file_stdin, "%d", &Ndim );
      if ( file_stdin_flag ) fprintf( stdout, "%d \n", Ndim );
      fprintf( stdout, "\n" );
   }
   ierr = MPI_Bcast( &Ndim, 1, MPI_INT, 0, MPI_COMM_WORLD );

   Glb_Grid_sz         = ( int* ) calloc( Ndim, sizeof( int ) );

   if ( my_tid == 0 )
   {
      for ( idir = 0; idir < Ndim; idir++ )
      {
          fprintf( stdout, "Enter the Glb_Grid_sz[ %d ] = ", idir );
          fscanf(  file_stdin , "%d", &Glb_Grid_sz[ idir ] );
          if ( file_stdin_flag )
             fprintf( stdout, "%d \n", Glb_Grid_sz[ idir ] );
      }
      fprintf( stdout, "\n" );
   }
   

   if ( file_stdin_flag )
      strcpy( type_str, "FILE " );
   else
      strcpy( type_str, "STDIN" );

   if ( my_tid == 0 )
   {
      fprintf( stdout, "{%d} The Ndim from %s = %d\n", my_tid,
                       type_str, Ndim );
      for ( idir = 0; idir < Ndim; idir++ )
         fprintf( stdout, "{%d} The Glb_Grid_sz[%d] from %s = %d\n",
                          my_tid, idir, type_str, Glb_Grid_sz[ idir ] );
   }
   
   N_task = -1;
   ierr = RGX_List_Processor_Names( MPI_COMM_WORLD, &N_task );

      N_task = 3;
      task_hostnames = ( char* ) calloc( N_task*line_Max, sizeof( char ) );

      RGX_List_Processor_Names( MPI_COMM_WORLD, &N_task, task_hostnames );

      for( ii = 0; ii < N_task; ii++ )
         printf( "tid=%d: node{ %d } = %s\n", my_tid, ii,
                 &task_hostnames[ ii*line_Max ] );

   ierr = MPI_Finalize();
}
